#include <stdio.h>
#include <stdarg.h>
#include <libudev.h>




static void
my_udev_log(struct udev *udev, int priority, const char *file, int line, const char *fn, const char *format, va_list args)
{
  printf("%s (%d) ", file, line);
  vprintf(format, args);
}


int main()
{
  struct udev *udev;
  struct udev_monitor *udev_monitor = NULL;

  udev = udev_new();
  if (udev == NULL) {
    printf("%s(%d) udev_new() ... failed\n", __FILE__, __LINE__);
    return 1;
  }

  udev_set_log_fn(udev, my_udev_log);

  udev_monitor = udev_monitor_new_from_netlink(udev, "udev");
  if (udev_monitor == NULL) {
    printf("%s(%d) udev_monitor_new_from_netlink() ... failed\n", __FILE__, __LINE__);
    goto ERROR_EXIT;
  }

  udev_monitor_unref(udev_monitor);
  udev_unref(udev);
  return 0;

 ERROR_EXIT:
  if (udev) {
    udev_unref(udev);
  }
  return 1;
}
